## freefem++ 3.17

=== download/blacs/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
include Bmake.inc

all-local: blacs 

# Downloading and compiling BLACS
# ------------------------------
# http://www.netlib.org/blacs/
# Hips information
DIRPKG=../pkg
SRCDIR=BLACS
PACKAGE1=$(DIRPKG)/mpiblacs.tgz
PACKAGE2=$(DIRPKG)/mpiblacs-patch03.tgz
PACKAGE3=$(DIRPKG)/blacstester.tgz
SERVER=http://www.netlib.org/blacs/
INSTALL=../..

SYSERRORS = 

blacs:FAIRE


FAIRE:$(SRCDIR)/FAIT
	$(MAKE) WHERE
	touch FAIRE

Bmake.inc: ../../config.status	Makefile Bmake-blacs.inc
	../../config.status  --file="Bmake.inc1:Bmake-blacs.inc"
	sed s/-DAdd__/-Df77IsF2C/ <Bmake.inc1 >Bmake.inc
	rm Bmake.inc1

$(SRCDIR)/FAIT: $(SRCDIR)
	#cd $(SRCDIR)/INSTALL/;$(MAKE) xintface xsyserrors xcmpi_sane xfmpi_sane xtc_CsameF77 xtc_UseMpich
	cd $(SRCDIR);$(MAKE) mpi 
	touch $(SRCDIR)/FAIT

WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	make install;  \
	echo blacs LD -L@DIR@/lib/blacs -lblacs_MPI-FREEFEM-0 	-lblacsF77init_MPI-FREEFEM-0	-lblacsCinit_MPI-FREEFEM-0  -lblacs_MPI-FREEFEM-0  >$(SRCDIR)/$(INSTALL)/lib/WHERE.blacs ;\
	fi

install: $(SRCDIR)/FAIT
	mkdir -p $(SRCDIR)/$(INSTALL)/lib/blacs
	cp $(SRCDIR)/LIB/*.a $(SRCDIR)/$(INSTALL)/lib/blacs/

$(SRCDIR): $(PACKAGE1) $(PACKAGE2) $(PACKAGE3)
	gunzip -c $(PACKAGE1) | tar xvf -
	gunzip -c $(PACKAGE2) | tar xvf -
	gunzip -c $(PACKAGE3) | tar xvf -
	cd $(SRCDIR)/SRC/MPI; patch -p1 < ../../../BLACS.patch
	cp Bmake.inc $(SRCDIR)
	mv $(SRCDIR)/SRC/MPI/Makefile $(SRCDIR)/SRC/MPI/Makefile.tmp
	sed -e 's;\.C;\.oo;g'\
	< $(SRCDIR)/SRC/MPI/Makefile.tmp \
	> $(SRCDIR)/SRC/MPI/Makefile
	touch $(SRCDIR)

$(PACKAGE1):
	-mkdir $(DIRPKG)
	cd $(DIRPKG);$(WGET)  $(SERVER)/`basename $(PACKAGE1)`

$(PACKAGE2):
	-mkdir $(DIRPKG)
	cd $(DIRPKG);$(WGET) $(SERVER)/`basename $(PACKAGE2)`

$(PACKAGE3):
	-mkdir $(DIRPKG)
	cd $(DIRPKG);$(WGET) $(SERVER)/`basename $(PACKAGE3)`

clean-local:
	-cd $(SRCDIR)/SRC/MPI &&  $(MAKE) clean -C $(SRCDIR)/SRC/MPI

clean: clean-local
	-rm Bmake.inc FAIRE
	-rm $(SRCDIR)/$(INSTALL)/lib/blacs/*.a
	-rm -rf $(SRCDIR)

.PHONY:$(SRCDIR)/$(INSTALL)  compile install

=== download/mmg3d/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
all-local: mmg3d

include ff-flags

# Downloading and compiling mmg3d
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./mmg3d4# lib#-$(mmg3d_VERSION)
PACKAGE=$(DIRPKG)/mmg3d4.0.tgz #mmg3dlib.tar.gz #-$(mmg3d_VERSION).tar.gz
INSTALL=..
mmg3d_VERSION=
# mmg3d pas sur internet
LIBMMG3D=$(INSTALL)/lib/libmmg3d-v4.a
OPT=4

mmg3d: build-4


build-4: 
	-make tag-tar
	if [ -d mmg3d4  ] ; then  make $(LIBMMG3D) install-4 WHERE ; else echo "Sorry no source " ; fi
$(LIBMMG3D):
	cd mmg3d4/build/sources/; $(CC) -c $(CFLAGS) *.c;
	$(AR) $(ARFLAGS) $(LIBMMG3D) mmg3d4/build/sources/*.o
	$(CC) $(CFLAGS) mmg3d4/build/sources/*.o -o ../bin/mmg3d $(STD_LIBS)
	touch build-4 FAIT-4
install-4:
	-mkdir ../include/mmg3d-v4/		
	cp mmg3d4/build/sources/*.h ../include/mmg3d-v4/
	touch FAIT-4


mmg3d: mmg3d-$(OPT)

mmg3d-1xxxx: 	
	if [ -f $(PACKAGE) ] ;then \
	   $(MAKE) FAIT-1; \
	else \
	   echo " file $(PACKAGE)  not found => no mmg3d tar file (download by hand) "; \
	fi
mmg3d-2xxx: FAIT-2xxx
FAIT-2xxx: 	
	@if [ -f ../pkg/$(MMG3DLIB_TAR) ] ;then \
	   echo tar zxf ../pkg/$(MMG3DLIB_TAR)  -C .. ;\
	   tar zxf ../pkg/$(MMG3DLIB_TAR)  -C .. ;\
	   touch FAIT-2 ;\
	else \
	   echo " file ../pkg/$(MMG3DLIB_TAR)  not found => no mmg3d tar file (download by hand) "; \
	fi

mmg3d-4:$(PACKAGE)

$(PACKAGE):
	-mkdir $(DIRPKG);
	cd $(DIRPKG);$(WGET) http://www.math.u-bordeaux1.fr/~dobj/logiciels/download/mmg3d4.0.tgz 
#http://www.math.u-bordeaux1.fr/~dobj/logiciels/download.php?file=`basename $(PACKAGE)`

FAIT-1: tag-tar
	$(MAKE) -C $(SRCDIR) lib
	touch FAIT-1
install:install-4 WHERE
install-1: FAIT-1
	-mkdir $(SRCDIR)/$(INSTALL)/include
	cp $(SRCDIR)/sources/libmmg3d.h  $(SRCDIR)/$(INSTALL)/include/libmmg3d.h
	-mkdir $(SRCDIR)/$(INSTALL)/lib
	cp $(SRCDIR)/objects/libmmg3d.a  $(LIBMMG3D)
install-2:

WHERE: 
	@-if [ -f FAIT-4 ] ; then \
	make install-4;  \
	echo mmg3d-v4  LD -L@DIR@/lib -lmmg3d-v4  >../lib/WHERE.mmg3d ;\
	echo mmg3d-v4 INCLUDE -I@DIR@/include/mmg3d-v4>> ../lib/WHERE.mmg3d ;\
	echo build WHERE ./lib/WHERE.mmg3d ;\
	fi


FAIRE: FAIT-4 install-4

tag-tar: $(PACKAGE)
	tar xvzf $(PACKAGE)
	touch mmg3d4/build/sources/dataff.h 	
	cd mmg3d4;patch -p1 <../patch-mmg3dv4.diff
	cat </dev/null >mmg3d4/build/sources/mmg3dConfig.h
	touch tag-tar
#	cp makefile-mmg3d.inc $(SRCDIR)/makefile


old-$(PACKAGE): 
	-mkdir $(DIRPKG);
	cd $(DIRPKG); $(WGET)   $(SERVER)/`basename $(PACKAGE)`


clean: 
	-rm ff-flags
	-rm -rf $(SRCDIR)/$(INSTALL)/lib/libmmg3d*.a  ../lib/libmmg3d-v4.a
	-rm -rf $(SRCDIR)/$(INSTALL)/include/mmg3d-v4
	-rm -r $(SRCDIR)
	-rm FAIT* mmg* flags-* build-4 tag-tar

ff-flags: ../Makefile Makefile
	grep 'abs_top_builddir *=' ../Makefile >> ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'STD_LIBS *=' ../Makefile >> ff-flags

.PHONY:$(SRCDIR)/$(INSTALL)

=== download/mshmet/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
all-local: mshmet

include ff-flags

# Downloading and compiling mshmet
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./mshmet$(mshmet_VERSION)
#-$(mshmet_VERSION)
PACKAGE=$(DIRPKG)/mshmet$(mshmet_VERSION).tgz
SERVER=http://www.ann.jussieu.fr/~frey/ftp/archives/
INSTALL=../..
mshmet_VERSION=.2011.03.06


# ---------------------- 
#     mshmetlib

MSHMET_DIR = $(abs_top_builddir)/download/mshmet/mshmet$(mshmet_VERSION)
MSHMET_SRCDIRNOLIB = $(MSHMET_DIR)/sources
MSHMET_SRCDIR = $(MSHMET_DIR)/sourceslib
MSHMET_OBJDIR = $(MSHMET_DIR)/objects

mshmet: FAIRE 

FAIRE:$(SRCDIR)/FAIT
	$(MAKE) WHERE $(SRCDIR)/$(INSTALL)  
	touch FAIRE

$(SRCDIR)/FAIT:$(SRCDIR)
	cd $(MSHMET_DIR); make
	touch $(SRCDIR)/FAIT

install:$(SRCDIR)/FAIT  ../../src/libMesh/libMesh.a 
	cp $(MSHMET_SRCDIR)/mshmetlib.h  $(SRCDIR)/$(INSTALL)/include/mshmetlib.h
	cp $(MSHMET_OBJDIR)/libmshmet.a  $(SRCDIR)/$(INSTALL)/lib/libmshmet.a
	cp ../../src/libMesh/libMesh.a  $(SRCDIR)/$(INSTALL)/lib/libMesh.a
	mkdir -p $(SRCDIR)/$(INSTALL)/include/libMesh
	cp ../../src/libMesh/*h  $(SRCDIR)/$(INSTALL)/include/libMesh

../../src/libMesh/libMesh.a :
	cd ../../src/libMesh && make 

WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	make install;  \
	echo mshmet  LD -L@DIR@/lib -lmshmet  >$(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet ;\
	echo mshmet INCLUDE -I@DIR@/include>> $(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet ;\
	echo libMesh  LD -L@DIR@/lib -lMesh  >$(SRCDIR)/$(INSTALL)/lib/WHERE.libMesh ;\
	echo libMesh INCLUDE -I@DIR@/include/libMesh >> $(SRCDIR)/$(INSTALL)/lib/WHERE.libMesh ;\
	fi


$(SRCDIR): $(PACKAGE)
	-mkdir mshmet$(mshmet_VERSION)
	cd mshmet$(mshmet_VERSION); tar xvzf ../$(PACKAGE)
	-mkdir $(MSHMET_SRCDIR)
	cp $(MSHMET_SRCDIRNOLIB)/*.c $(MSHMET_SRCDIRNOLIB)/*.h $(MSHMET_SRCDIR)
	cp $(MSHMET_SRCDIRNOLIB)/compil.date $(MSHMET_SRCDIR)
	cp mshmetlib-internal.h mshmetlib.c mshmetlib.h $(MSHMET_SRCDIR)/
	rm $(MSHMET_SRCDIR)/mshmet.c
	cp Makefile-mshmet.inc $(MSHMET_DIR)/makefile
	cd $(MSHMET_SRCDIR); patch -p2 < ../../mshmet.2011.03.06.patch

$(PACKAGE):
	-mkdir $(DIRPKG);
	cd $(DIRPKG);$(WGET)   $(SERVER)/`basename $(PACKAGE)`

clean-local: 
	-make -C $(MSHMET_DIR) clean;
	-rm $(MSHMET_OBJDIR)/libmshmet.a

clean: clean-local
	-rm ff-flags
	-rm -r $(MSHMET_DIR)
	-rm $(SRCDIR)/$(INSTALL)/lib/WHERE.libMesh $(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet 
	-rm $(SRCDIR)/$(INSTALL)/include/mshmetlib.h
	-rm $(SRCDIR)/$(INSTALL)/lib/libmshmet.a
	-rm -r $(SRCDIR)/$(INSTALL)/lib/libMesh.a
	-rm -r $(SRCDIR)/$(INSTALL)/include/libMesh
	-rm -rf $(SRCDIR)
	-rm FAIT FAIRE 

ff-flags: ../Makefile 
	grep 'abs_top_builddir *=' ../Makefile >> ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'mshmet_VERSION *=' ./Makefile >> ff-flags


.PHONY: $(SRCDIR)/$(INSTALL)

=== download/mumps/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
include Makefile.inc

all-local: mumps

# Downloading and compiling mumps
# ------------------------------
DIRPKG=../pkg
SRCDIR=MUMPS_$(VERSION)
PACKAGE1=$(DIRPKG)/MUMPS_$(VERSION).tar.gz
INSTALL=../..
VERSION=4.10.0

mumps: FAIRE-$(VERSION)

$(SRCDIR)/FAIT: $(SRCDIR)/tag-tar
	cp Makefile.inc $(SRCDIR)
	cd $(SRCDIR);make d z
	touch $(SRCDIR)/FAIT	
install: $(SRCDIR)/FAIT
	-mkdir -p $(SRCDIR)/$(INSTALL)/include/libseq
	cp $(SRCDIR)/include/*.h $(SRCDIR)/$(INSTALL)/include/
	cp $(SRCDIR)/libseq/*.h  $(SRCDIR)/$(INSTALL)/include/libseq
	-mkdir -p $(SRCDIR)/$(INSTALL)/lib
	cp $(SRCDIR)/lib/*.a $(SRCDIR)/$(INSTALL)/lib/
	cp $(SRCDIR)/libseq/libmpiseqFREEFEM.a $(SRCDIR)/$(INSTALL)/lib/

WHERE: 
	if [ -f $(SRCDIR)/FAIT  ] ;then \
	$(MAKE) install ; \
	echo mumps LD -L@DIR@/lib   -ldmumpsFREEFEM -lzmumpsFREEFEM  -lmumps_commonFREEFEM -lpordFREEFEM   >$(SRCDIR)/$(INSTALL)/lib/WHERE.mumps ;\
	echo mumps INCLUDE -I@DIR@/include  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.mumps ;\
	echo libseq LD -L@DIR@/lib  -lmpiseqFREEFEM   >>$(SRCDIR)/$(INSTALL)/lib/WHERE.mumps ;\
	echo libseq INCLUDE -I@DIR@/include/libseq>> $(SRCDIR)/$(INSTALL)/lib/WHERE.mumps ;\
	fi


FAIRE-$(VERSION):
	$(MAKE) install WHERE 
	touch FAIRE-$(VERSION)

Makefile.inc: ../../config.status	Makefile Makefile-mumps-$(VERSION).inc
	../../config.status  --file="Makefile.inc:Makefile-mumps-$(VERSION).inc"

$(SRCDIR)/$(INSTALL): $(SRCDIR)/tag-tar

$(SRCDIR)/tag-tar:$(PACKAGE1)
	tar xvzf $(PACKAGE1)
#	patch -d MUMPS_4.9.2   -p 1    <MUMPS_4.9.2.patch
	touch $(SRCDIR)/tag-tar

$(PACKAGE1):
	cd `dirname $@`; $(WGET)   http://graal.ens-lyon.fr/MUMPS/`basename $(PACKAGE1)`
clean-local:
	-cd $(SRCDIR) &&  $(MAKE) clean -C $(SRCDIR) 

clean: clean-local
	rm Makefile.inc FAIRE*
	-rm -rf $(SRCDIR)/$(INSTALL)/include/*mumps*
	-rm -rf $(SRCDIR)/$(INSTALL)/lib/lib*mumps* $(SRCDIR)/$(INSTALL)/lib/libpord*.a $(SRCDIR)/$(INSTALL)/lib/libmpiseq*.a
	-rm -rf $(SRCDIR)

.PHONY:$(SRCDIR)/$(INSTALL)

=== download/nlopt/Makefile ===
URL="http://ab-initio.mit.edu/nlopt/nlopt-2.2.4.tar.gz"
SRCDIR=nlopt-2.2.4
TARGZ=../pkg/$(SRCDIR).tar.gz
include Make.defs

all: FAIRE

FAIRE: ../pkg $(SRCDIR)/FAIT 

$(SRCDIR)/FAIT: $(TARGZ)
	tar zxvf $(TARGZ)
	cd $(SRCDIR); ./configure  --with-cxx --prefix="$(FFDOWNLOAD)" CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)" CC="$(CC)" CFLAGS="$(CFLAGS)" 
	cd $(SRCDIR); $(MAKE) install
	touch $(SRCDIR)/FAIT
	$(MAKE) WHERE
$(TARGZ):
	cd ../pkg;$(WGET) $(URL)
../pkg:
	mkdir $@
clean:
	rm -rf $(SRCDIR) Make.defs 
WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	echo nlopt LD -L@DIR@/lib -lnlopt_cxx  >../lib/WHERE.nlopt ;\
	echo nlopt INCLUDE -I@DIR@/include >> ../lib/WHERE.nlopt ;\
	fi

Make.defs: ../../config.status	Makefile Make.inc
	../../config.status  --file="Make.defs:Make.inc"

=== download/scalapack/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
include SLmake.inc

all-local: scalapack

# Downloading and compiling scalapack
# ------------------------------
# http://www.netlib.org/scalapack/
# Hips information
DIRPKG=../pkg
SRCDIR=scalapack-1.8.0
PACKAGE1=$(DIRPKG)/scalapack-1.8.0.tgz
SERVER=http://www.netlib.org/scalapack/
INSTALL=../..
DIR1 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/TOOLS/LAPACK/*.o
DIR2 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/TOOLS/*.o
DIR3 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/PBLAS/SRC/PBBLAS/*.o
DIR4 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/PBLAS/SRC/PTZBLAS/*.o
DIR5 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/PBLAS/SRC/PTOOLS/*.o
DIR6 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/PBLAS/SRC/*.o
DIR7 = $(abs_top_builddir)/download/scalapack/$(SRCDIR)/REDIST/SRC/*.o
DIR8 =  $(abs_top_builddir)/download/scalapack/$(SRCDIR)/SRC/*.o

scalapack: FAIRE

$(SRCDIR)/FAIT:$(SRCDIR)/tag-tar
	cp SLmake.inc $(SRCDIR)
	cd $(SRCDIR);$(MAKE) lib
	rm $(SRCDIR)/libscalapack.a
	$(ARCH) $(ARCHFLAGS) $(SRCDIR)/libscalapack.a $(DIR1) $(DIR2) $(DIR3) $(DIR4) $(DIR5) $(DIR6) $(DIR7) $(DIR8)
	$(RANLIB) $(SRCDIR)/libscalapack.a
	touch $(SRCDIR)/FAIT
install:
	mkdir -p $(SRCDIR)/$(INSTALL)/include
	cp $(SRCDIR)/SRC/*.h $(SRCDIR)/$(INSTALL)/include
	mkdir -p $(SRCDIR)/$(INSTALL)/lib
	cp $(SRCDIR)/libscalapack.a $(SRCDIR)/$(INSTALL)/lib

WHERE:
	if [ -f $(SRCDIR)/FAIT ] ; then \
	make install;  \
	echo scalapack LD -L@DIR@/lib  -lscalapack   >$(SRCDIR)/$(INSTALL)/lib/WHERE.scalapack ;\
	echo scalapack INCLUDE -I@DIR@/include  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scalapack ;\
	fi

FAIRE: $(SRCDIR)/FAIT
	$(MAKE) WHERE
	touch FAIRE 

SLmake.inc: ../../config.status	Makefile
	../../config.status  --file="SLmake.inc:SLmake-scalapack.inc"

$(SRCDIR)/tag-tar: $(PACKAGE1)
	gunzip -c $(PACKAGE1) | tar xvf -
	touch $(SRCDIR)/tag-tar

$(PACKAGE1):
	-mkdir $(DIRPKG)
	cd $(DIRPKG);$(WGET)  $(SERVER)/`basename $(PACKAGE1)`

clean-local:
	-cd $(SRCDIR) && $(MAKE) cleanlib  -C $(SRCDIR)

clean: clean-local
	rm SLmake.inc FAIRE FAIT
	-rm -rf $(SRCDIR)/$(INSTALL)/include/{pblas.h,pxsyevx.h,tools.h}
	-rm -rf $(SRCDIR)/$(INSTALL)/lib/libscalapack.a
	-rm -rf $(SRCDIR)

.PHONY:$(SRCDIR)/$(INSTALL)

=== download/scotch/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
include Makefile.inc

all-local: scotch

# Downloading and compiling scotch
# -------------------------------
# http://gforge.inria.fr/frs/download.php/23391/scotch_5.1.7_esmumps.tar.gz
# Scotch information
DIRPKG=../pkg
SRCDIR=scotch_$(scotch_VERSION)
PACKAGE=$(DIRPKG)/scotch_$(scotch_VERSION_LOCAL).tar.gz
SERVER=http://gforge.inria.fr/frs/download.php/23391
INSTALL=../..
scotch_VERSION=5.1_esmumps
scotch_VERSION_LOCAL=5.1.6_esmumps

scotch: FAIRE

$(SRCDIR)/AFAIRE:
	$(MAKE) install 

FAIRE: $(SRCDIR)/FAIT
	$(MAKE)  WHERE
	touch FAIRE
Makefile.inc: ../../config.status Makefile-scotch.inc Makefile
	../../config.status  --file="Makefile.inc:Makefile-scotch.inc"
	case `uname` in *CYGWIN*)  cp Makefile.inc Makefile.inn; sed "s/COPTIONS =/COPTIONS = -D__VC__/" <Makefile.inn > Makefile.inc; rm Makefile.inn ;; esac 

$(SRCDIR)/FAIT: $(SRCDIR)
	cp Makefile.inc $(SRCDIR)/src/
	cd $(SRCDIR)/src/; make scotch
	cd $(SRCDIR)/src/; make ptscotch
	touch $(SRCDIR)/FAIT

install:$(SRCDIR)/FAIT
	mkdir -p $(SRCDIR)/$(INSTALL)/include/scotch
	cp $(SRCDIR)/include/*.h $(SRCDIR)/$(INSTALL)/include/scotch/
	cp $(SRCDIR)/lib/*.a $(SRCDIR)/$(INSTALL)/lib/
WHERE:
	if [ -f  $(SRCDIR)/FAIT ] ; then \
	$(MAKE) install; \
	echo ptscotch LD -L@DIR@/lib  -lptesmumps -lptscotch -lptscotcherr   >$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch ;\
	echo ptscotch INCLUDE -I@DIR@/include/scotch  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch ;\
	echo scotch LD -L@DIR@/lib   -lscotch -lscotcherr   >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch ;\
	echo scotch INCLUDE -I@DIR@/include/scotch  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch ;\
	fi

$(SRCDIR): $(PACKAGE)
	tar xvzf $(PACKAGE)
	cd $(SRCDIR)/src/libscotch/; patch -p1 < ../../../scotch_5.1_esmumps.patch;
	touch $(SRCDIR)

$(PACKAGE):
	-mkdir $(DIRPKG);
	cd $(DIRPKG);$(WGET)    $(SERVER)/`basename $(PACKAGE)`

clean-local:
	-cd $(SRCDIR)/src && $(MAKE)  realclean  -C $(SRCDIR)/src
clean: clean-local
	-rm Makefile.inc
	-rm -rf $(SRCDIR)
.PHONY:$(SRCDIR)/$(INSTALL)

=== download/superlu/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------
# $Id$

all-local: superlu

# Downloading and compiling Tetgen
# ------------------------------

# SUPERLU information
#http://crd.lbl.gov/~xiaoye/SuperLU/superlu_4.0.tar.gz
DIRPKG=../pkg
SRCDIR=SuperLU_4.0
PACKAGE=superlu_4.0.tar.gz
PACKAGE_PATH=$(DIRPKG)/$(PACKAGE)
SERVER=http://crd.lbl.gov/~xiaoye/SuperLU/
INSTALL=../..
SUPERLU_VERSION=4.0
SUPERLULIB=../$(INSTALL)/lib/libsuperlu_$(SUPERLU_VERSION).a
include  ff-FLAGS

### LAPACK 
LAAUX 	= lsame.o xerbla.o
SLASRC 	= slacon.o 
DLASRC	= dlacon.o
CLASRC	= clacon.o scsum1.o icmax1.o
ZLASRC	= zlacon.o dzsum1.o izmax1.o
SCLAUX 	= slamch.o
DZLAUX 	= dlamch.o

### SuperLU 
ALLAUX 	= superlu_timer.o util.o memory.o get_perm_c.o mmd.o \
	  sp_coletree.o sp_preorder.o sp_ienv.o relax_snode.o \
	  heap_relax_snode.o colamd.o

SLUSRC = \
	sgssv.o sgssvx.o \
	ssp_blas2.o ssp_blas3.o sgscon.o  \
	slangs.o sgsequ.o slaqgs.o spivotgrowth.o \
	sgsrfs.o sgstrf.o sgstrs.o scopy_to_ucol.o \
	ssnode_dfs.o ssnode_bmod.o \
	spanel_dfs.o spanel_bmod.o sreadhb.o \
	scolumn_dfs.o scolumn_bmod.o spivotL.o spruneL.o \
	smemory.o sutil.o smyblas2.o

DLUSRC = \
	dgssv.o dgssvx.o \
	dsp_blas2.o dsp_blas3.o dgscon.o \
	dlangs.o dgsequ.o dlaqgs.o dpivotgrowth.o  \
	dgsrfs.o dgstrf.o dgstrs.o dcopy_to_ucol.o \
	dsnode_dfs.o dsnode_bmod.o \
	dpanel_dfs.o dpanel_bmod.o dreadhb.o \
	dcolumn_dfs.o dcolumn_bmod.o dpivotL.o dpruneL.o \
	dmemory.o dutil.o dmyblas2.o ## dgstrsL.o dgstrsU.o

CLUSRC = \
	scomplex.o cgssv.o cgssvx.o csp_blas2.o csp_blas3.o cgscon.o \
	clangs.o cgsequ.o claqgs.o cpivotgrowth.o  \
	cgsrfs.o cgstrf.o cgstrs.o ccopy_to_ucol.o \
	csnode_dfs.o csnode_bmod.o \
	cpanel_dfs.o cpanel_bmod.o creadhb.o \
	ccolumn_dfs.o ccolumn_bmod.o cpivotL.o cpruneL.o \
	cmemory.o cutil.o cmyblas2.o

ZLUSRC = \
	dcomplex.o zgssv.o zgssvx.o zsp_blas2.o zsp_blas3.o zgscon.o \
	zlangs.o zgsequ.o zlaqgs.o zpivotgrowth.o  \
	zgsrfs.o zgstrf.o zgstrs.o zcopy_to_ucol.o \
	zsnode_dfs.o zsnode_bmod.o \
	zpanel_dfs.o zpanel_bmod.o zreadhb.o \
	zcolumn_dfs.o zcolumn_bmod.o zpivotL.o zpruneL.o \
	zmemory.o zutil.o zmyblas2.o


OBJ_SUPERLU = $(ALLAUX) $(LAAUX) \
 $(SLUSRC)  $(SLASRC) $(SCLAUX) \
 $(DLUSRC)  $(DLASRC) $(DZLAUX) \
 $(CLUSRC)  $(CLASRC) \
 $(ZLUSRC)  $(ZLASRC) 

superlu: FAIT

FAIT:	
	$(MAKE)  install 
	touch FAIT


FAIRE:$(SRCDIR)
	cd $(SRCDIR)/SRC; $(MAKE) -f ../../ff-FLAGS  $(OBJ_SUPERLU)
	touch FAIRE

install: FAIRE WHERE
	cd $(SRCDIR)/SRC; $(AR) $(ARFLAGS) $(SUPERLULIB)  $(OBJ_SUPERLU)
	cd $(SRCDIR)/SRC; $(RANLIB) $(SUPERLULIB) 
	cp $(SRCDIR)/SRC/s*h  $(SRCDIR)/$(INSTALL)/include
WHERE:
	echo superlu LD -L@DIR@/lib -lsuperlu_$(SUPERLU_VERSION)  >$(SRCDIR)/$(INSTALL)/lib/WHERE.superlu
	echo superlu INCLUDE -I@DIR@/include >> $(SRCDIR)/$(INSTALL)/lib/WHERE.superlu




$(SRCDIR)/$(INSTALL): 
	mkdir $(SRCDIR)/$(INSTALL)


$(SRCDIR): $(PACKAGE_PATH)
	tar xvzf $(PACKAGE_PATH)
	touch $(SRCDIR)

$(PACKAGE_PATH):
	-mkdir $(DIRPKG);
	cd $(DIRPKG);$(WGET)  $(SERVER)$(PACKAGE)

clean-local:
	-rm -rf superlu*
clean:
	-rm $(SRCDIR)/SRC/$(SUPERLULIB)
	-rm $(SRCDIR)/$(INSTALL)/include/slu*h 
	-rm $(SRCDIR)/$(INSTALL)/include/supermatrix.h
	-rm -r $(SRCDIR) ff-FLAGS
	-rm -rf FAIT FAIRE


ff-FLAGS: ../Makefile  Makefile 
	grep '^CXX *=' ../Makefile >>$@
	grep '^CC *=' ../Makefile >>$@
	grep '^CFLAGS *=' ../Makefile >>$@
	grep '^BLAS[A-Z ]*='  ../Makefile|grep =  >>$@
	grep '^AR *='  ../Makefile|grep =  >>$@
	grep '^ARFLAGS *='  ../Makefile|grep =  >>$@
	grep '^RANLIB *='    ../Makefile|grep =  >>$@
	grep '^WGET *='    ../Makefile|grep =  >>$@

=== download/tetgen/Makefile ===
# and compiling extra libraries
# -----------------------------------------

# $Id$

include cxxflags
all-local: tetgen

# Downloading and compiling Tetgen
# ------------------------------

# Tetgen information
DIRPKG=../pkg
SRCDIR=tetgen$(tetgen_VERSION)
PACKAGE=$(DIRPKG)/tetgen$(tetgen_VERSION).tar.gz
SERVER=http://tetgen.berlios.de/files
INSTALL=../..
tetgen_VERSION=1.4.3

tetgen: FAIRE 


FAIRE:install $(SRCDIR)/FAIT cxxflags 
	touch FAIRE


$(SRCDIR)/FAIT: $(SRCDIR)/tags  cxxflags 
	cd $(SRCDIR);$(CXX) $(CXXFLAGS) -DSELF_CHECK  -DNDEBUG -DTETLIBRARY -c tetgen.cxx
	cd $(SRCDIR);$(CXX) $(CXXFLAGS) -DSELF_CHECK  -DNDEBUG -DTETLIBRARY -c predicates.cxx
	touch $(SRCDIR)/FAIT
WHERE: $(SRCDIR)/FAIT
	echo tetgen LD -L@DIR@/lib -ltet  >$(SRCDIR)/$(INSTALL)/lib/WHERE.tetgen
	echo tetgen  INCLUDE -I@DIR@/include >> $(SRCDIR)/$(INSTALL)/lib/WHERE.tetgen
install:$(SRCDIR)/FAIT WHERE
	cd $(SRCDIR);$(AR) $(ARFLAGS)  $(INSTALL)/lib/libtet.a tetgen.o predicates.o
	cp $(SRCDIR)/tetgen.h $(SRCDIR)/$(INSTALL)/include 



$(SRCDIR)/tags: $(PACKAGE)
	tar xvzf $(PACKAGE)
	touch $(SRCDIR)/tags
#	cd tetgen1.4.2;patch -p1 <../tetgen1.4.2.patch 

$(PACKAGE):
	cd $(DIRPKG);$(WGET)   $(SERVER)/`basename $(PACKAGE)`



clean-local:
	-rm -rf tetgen1.4.?  FAIT FAIRE 
clean:
	-rm $(SRCDIR)/$(INSTALL)/lib/libtet.a
	-rm $(SRCDIR)/$(INSTALL)/include/tetgen.h
	-rm FAIT
	-rm -rf tetgen1.4.?
cxxflags: ../Makefile  Makefile
	grep 'CXX *=' ../Makefile >cxxflags
	grep 'CC *=' ../Makefile >>cxxflags
#  bug under ubuntu et cygwin si option optime  -O3 remove optim ???
	grep 'CXXFLAGS *=' ../Makefile | sed 's/ -O[0-9]* / /'  >>cxxflags
	grep 'WGET *=' ../Makefile >>cxxflags
	grep 'AR *=' ../Makefile >>cxxflags
	grep 'ARFLAGS *=' ../Makefile >>cxxflags
.PHONY:$(SRCDIR)/$(INSTALL)

=== download/yams/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

# $Id$
all-local: yams

include ff-flags

# Downloading and compiling yams
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./freeyams$(yams_VERSION)
#-$(yams_VERSION)
PACKAGE=$(DIRPKG)/freeyams$(yams_VERSION).tgz
SERVER=http://www.ann.jussieu.fr/~frey/ftp/archives/
INSTALL=../..
yams_VERSION=.2011.09.23

# ---------------------- 
#     yamslib

YAMS_DIR = $(abs_top_builddir)/download/yams/$(SRCDIR)
YAMS_SRCDIRNOLIB = $(YAMS_DIR)/sources
YAMS_SRCDIR = $(YAMS_DIR)/sourceslib
YAMS_OBJDIR = $(YAMS_DIR)/objects

yams: FAIRE  



FAIRE: yamslib_internal.h yamslib.c yamslib.h  ../Makefile
	$(MAKE)  install  WHERE
	touch FAIRE

$(SRCDIR)/FAIT: $(SRCDIR)/PATCH  yamslib_internal.h yamslib.c yamslib.h 
	cp yamslib_internal.h yamslib.c yamslib.h $(YAMS_SRCDIR)/
	cp makefile-yams.inc $(YAMS_DIR)/makefile
	cd $(YAMS_DIR); make
	touch $(SRCDIR)/FAIT
install: $(SRCDIR)/FAIT
	sed  s/defines.h/freeyams_defines.h/ <$(YAMS_SRCDIR)/yamslib.h  >$(SRCDIR)/$(INSTALL)/include/freeyamslib.h
	cp $(YAMS_SRCDIR)/defines.h  $(SRCDIR)/$(INSTALL)/include/freeyams_defines.h
	-mkdir $(SRCDIR)/$(INSTALL)/lib	
	cp $(YAMS_OBJDIR)/libyams.a  $(SRCDIR)/$(INSTALL)/lib/libfreeyams.a
WHERE: 
	-if [ -f $(SRCDIR)/FAIT ] ; then \
	make install;  \
	echo freeyams  LD -L@DIR@/lib -lfreeyams  >$(SRCDIR)/$(INSTALL)/lib/WHERE.freeyams ;\
	echo freeyams INCLUDE -I@DIR@/include>> $(SRCDIR)/$(INSTALL)/lib/WHERE.freeyams ;\
	fi


$(SRCDIR)/PATCH: $(PACKAGE) 
	-mkdir -p $(SRCDIR)
	cd $(SRCDIR); tar xvzf ../$(PACKAGE)
	-mkdir $(YAMS_SRCDIR)
	cp $(YAMS_SRCDIRNOLIB)/*.c $(YAMS_SRCDIRNOLIB)/*.h $(YAMS_SRCDIR)
	rm $(YAMS_SRCDIR)/memory.c 
	cp $(YAMS_SRCDIRNOLIB)/compil.date $(YAMS_SRCDIR)
	cd $(YAMS_SRCDIR); patch -p2 < ../../freeyams$(yams_VERSION).patch
	mv  $(YAMS_SRCDIR)/yams.c $(YAMS_SRCDIR)/..
	touch $(SRCDIR)/PATCH

$(PACKAGE):
	-mkdir $(DIRPKG);
	cd $(DIRPKG);$(WGET)   $(SERVER)/`basename $(PACKAGE)`

clean-local: 
	-rm FAIRE FAIT  $(SRCDIR)/FAIT
	-cd $(YAMS_DIR) &&  $(MAKE) -C $(YAMS_DIR)  clean
	-rm $(YAMS_OBJDIR)/libyams.a

clean: clean-local
	-rm ff-flags
	-rm $(SRCDIR)/$(INSTALL)/lib/libfreeyams.a
	-rm $(SRCDIR)/$(INSTALL)/include/*freeyams*.h
	-rm $(SRCDIR)/$(INSTALL)/lib/WHERE.freeyams
	-rm -rf $(YAMS_DIR)
	-rm -rf $(SRCDIR)
	-rm FAIT FAIRE

ff-flags: ../Makefile Makefile
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'yams_VERSION *=' ./Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'LIBS *=' ../Makefile >> ff-flags


.PHONY: $(SRCDIR)/$(INSTALL)

=== debian/changelog ===
freefem++ (3.17-2) unstable; urgency=low

  * Fix build failure on hurd-i386 architecture.
  * Rename kfreebsd.patch to examples++-load-load-link-in.patch and ammend it.

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Thu, 29 Dec 2011 16:31:00 +0200

freefem++ (3.17-1) unstable; urgency=low

  * New upstream release.
  * Add build-deps for libgmm++-dev.

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sun, 27 Nov 2011 14:17:00 +0200

=== debian/control ===
Source: freefem++
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@grenoble.cnrs.fr>, 
 Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.2.3~), autotools-dev, gawk, gfortran, 
 flex, bison, libxt-dev, libxext-dev, libxxf86vm-dev, libhypre-dev, 
 libxpm-dev, mpi-default-dev, libfftw3-dev, libblas-dev, libgsl0-dev,
 libarpack2-dev, libsuitesparse-dev, libsuperlu3-dev, imagemagick, 
 libfltk1.3-dev | libfltk-dev, freeglut3-dev, texlive, texlive-extra-utils, 
 texlive-latex-extra, texlive-font-utils, libmumps-ptscotch-dev,
 libmumps-dev, libblacs-mpi-dev, libscalapack-mpi-dev, libgmm++-dev, 
 libscotch-dev, ghostscript, libptscotch-dev, libmumps-scotch-dev
Standards-Version: 3.9.2
Homepage: http://www.freefem.org/ff++/
Vcs-Git: git://git.debian.org/debian-science/packages/freefempp.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/freefempp.git

Package: freefem++
Architecture: any
Section: math
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Provides the binaries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the executables of FreeFem++.

Package: libfreefem++
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Provides the shared libraries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the shared libraries of FreeFem++.

Package: libfreefem++-dev
Architecture: any
Section: libdevel
Depends: libfreefem++, ${shlibs:Depends}, ${misc:Depends}
Description: Provides the development files of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the development files of FreeFem++.

Package: freefem++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Provides the documentation of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve. 
 .
 This package contains the documentation files of FreeFem++.

## freefem++ 3.18.1

=== debian/changelog ===
freefem++ (3.18.1-1) unstable; urgency=low

  * New upstream release.
  * Create new patch for documentation build.

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Fri, 17 Feb 2012 21:29:00 +0200

freefem++ (3.18-1) unstable; urgency=low

  * New upstream release.

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sat, 4 Feb 2012 21:10:00 +0200
